/*
 * @author Lenidas de Oliveira Brando
 * @see TrataMouse    
 * Apenas para poder desenhar na janela central e poder fazer tratamento "grfico" de mouse
 * Note que neste exemplo NO est implementada a tcnica de "double buffering" => "flicker" na tela
 */

import java.awt.Color;
import java.awt.Panel;
import java.awt.Graphics;
import java.awt.Dimension;
import java.awt.event.*;

// MouseListener: precisa de "mouseClicked", "mousePressed", "mouseReleased", "mouseEntered", " mouseExited"
public class JanelaCentral extends Panel implements 
             MouseListener,        // pega cliques
             MouseMotionListener { // pega movimentos

  int pos_x = -1,
     pos_y;

  boolean mover = false; // sobre a "string" na janela: se clicar move, clicar novamente para

  public JanelaCentral() {
    addMouseListener(this);     addMouseMotionListener(this);
    }


  public synchronized void paint(Graphics g) {
    Dimension d = getSize();
    if (pos_x==-1) { // ainda no definidas posies
       pos_x = d.width/2;
       pos_y = d.height/2;
       }

    g.setColor(Color.black); // preenche retntulo preto
    g.fillRect( 1,1, d.width-1,d.height-1); //
    g.setColor(Color.white); // faz uma borda
    g.drawRect( 2,2, d.width-4,d.height-4); //
    g.drawString(TrataMouse.str_msg, pos_x, pos_y); // pega var. esttica c/ msg em TrataMouse
    }

  // reposiciona "string" "teste de mouse" para as coordenadas x,y
  private void redesenha(int x, int y) {
    pos_x = x;
    pos_y = y;
    repaint(); // atualiza desenho
    }

  public void mouseClicked(java.awt.event.MouseEvent me) {
         int x = me.getX(), // para o mouseDragged
             y = me.getY();
         redesenha(x,y);
         mover = !mover;
         System.out.println("mouseClicked: "+me);
         }
  public void mousePressed(java.awt.event.MouseEvent me) {
         System.out.println("mousePressed: "+me);
         }
  public void mouseReleased(java.awt.event.MouseEvent me) {
         System.out.println("mouseReleased: "+me);
         }
  public void mouseEntered(java.awt.event.MouseEvent me) {
         System.out.println("mouseEntered: "+me);
         }
  public void mouseExited(java.awt.event.MouseEvent me) {
         System.out.println("mouseExited: "+me);
         }

  // MouseMotionListener: arrastar e mover mouse sobre esta JanelaCentral
  public void mouseDragged(MouseEvent mme) {
    int x = mme.getX(),  y = mme.getY();
    System.out.println("mouseDragged: "+mme);  // 
    redesenha(x,y);
    }

 public void mouseMoved(MouseEvent mme) {
    int x = mme.getX();
    int y = mme.getY();
    // System.out.println("mouseMoved: "+mme); // esta msg  desagradvel, enche a tela - retire comentrio e teste
    if (mover) redesenha(x,y);
    }


  }
