/*
 * @author Lenidas de Oliveira Brando
 * @see    JanelaCentral
 * Exemplo para tratar cliques em Button, Choice e Checkbox
 */

import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;


// ActionListener -> precisa do "actionPerformed(ActionEvent)"
public class TrataMouse extends Applet implements 
             ActionListener, // para clique em Button, ...
             ItemListener {  // para eventos em Choice e Checkbox

  Container JanelaPrincipal; // conter a janela principal, com todas as imagens

  boolean applet = false; // usado para construir corretamente o Applet ou Aplicativo

  public static String str_msg = "teste de mouse";
		  
  Label L = new Label("Botes, escolhas e marcas (mouse) - MAC 323 - 2003");
  Button b_fim  = new Button("Fim");
  Button b_msg  = new Button("Msg");
  Button b_esc  = new Button("Escolha");
  TextField text = new TextField("digite algo               "); // tamanho da String def. tam. da TextField
  Choice escolheL = new Choice ();
  Checkbox check;

  String esc1 = new String("Opo 1");
  String esc2 = new String("Opo 2");

  public static Color cor_Msg   = new Color( 64, 128, 198); 

  public TrataMouse () {
    }

  // Mouse: trata Choice
  public void itemStateChanged(ItemEvent evt) { 
    Object obj = evt.getItem();
    System.out.println(obj); //evt.paramString());
    if (evt.getStateChange() == ItemEvent.SELECTED) {
       String str_choice = new String((String)evt.getItem());
       System.out.println("Escolha: "+str_choice);
       text.setText("Escolha: "+str_choice);
       }
    if (obj instanceof String) // para o caso de precisar separar os eventos...
       System.out.println("Voc acabou de clicar no \"checkbox\" ou \"choice\" "+(String)obj);
    }

  // Mouse: trata Button
  public void actionPerformed(ActionEvent e) {
   String s = e.getActionCommand();
   if ( s.equals ("Fim") ) {
      if (! applet) System.exit(0);
      }
   else
   if ( s.equals ("Msg") ) { 
      System.out.println(text.getText());
      text.setText("Clicou no \"boto\" "+s);
      }
   else
   if ( s.equals ("Escolha") ) {
      //int ind_ordenador = Integer.parseInt( escolheL.getSelectedItem());
      String str_lista = escolheL.getSelectedItem(); // pega mtodo atual
      //System.out.println( str_lista);
      if ( str_lista.equals(esc1) ) {
	 System.out.println("A escolha atual : "+str_lista);
         text.setText("A escolha atual : "+str_lista);
         }
      else
      if ( str_lista.equals(esc2) ) {
	 System.out.println("Escolha: "+str_lista);
         text.setText("Escolha: "+str_lista);
         }
      }
   }

  private void montaJanela () {
    setLayout(new BorderLayout()); // (new FlowLayout());
    Panel janelaSup    = new Panel(),
          janelaBotoes = new Panel(),
          janelaInf    = new Panel();

    if (applet) { //  && !frame) {
       JanelaPrincipal = this; //
       }
    else {
       JanelaPrincipal = new Frame("Trata boto e choice - MAC 323 - 2003");
       ((Frame)JanelaPrincipal).addWindowListener(new WindowAdapter() { 
                             public void windowClosing(WindowEvent e) { System.exit(0); } } );
       JanelaPrincipal.setSize(450,200);
       JanelaPrincipal.setVisible(true);
       }

    JanelaPrincipal.setLayout(new BorderLayout()); //(new FlowLayout());
    JanelaPrincipal.setBackground(cor_Msg );
    JanelaPrincipal.setFont(new Font("Arial", Font.BOLD, 10));

    janelaSup.setLayout(new BorderLayout()); // (new FlowLayout());

    escolheL.addItem (new String (esc1));
    escolheL.addItem (new String (esc2)); 
    escolheL.setFont(new Font("Arial", Font.BOLD, 10));
    escolheL.setForeground(Color.white);
    escolheL.addItemListener(this); // o "this" precisa ser o "implements ItemListener"

    check = new Checkbox("marcar");
    b_fim.addActionListener(this);
    b_msg.addActionListener(this);
    b_esc.addActionListener(this);
    check.addItemListener(this);

    if (!applet) janelaBotoes.add(b_fim); // (b_fim,"East");       //
    janelaBotoes.add(b_msg);
    janelaBotoes.add(b_esc);
    janelaBotoes.add(check);

    janelaSup.add(L,"North");
    janelaSup.add(janelaBotoes,"South");
    janelaInf.add(text);
    janelaInf.add(escolheL);

    // Mtodos interressantes para TextField:
    // text.setEditable(false); text.setEnabled(true); text.setBackground(fundo_textfield);
    // text.setText("qq texto");

    JanelaPrincipal.add(janelaSup,"North");

    JanelaCentral centro = new JanelaCentral();
    centro.setSize(JanelaPrincipal.getSize().width, JanelaPrincipal.getSize().height-100);
    centro.setVisible(true);
    JanelaPrincipal.add(centro,"Center");

    JanelaPrincipal.add(janelaInf,"South");
    }

  // Inicia quando Applet (aps do construtor)
  //  chamado aps o "Applet" ser instanciado
  public void init (){  // sempre que for carregado por applet, entra aqui
    applet = true;      // sempre que for carregado por applet, entra aqui
    
    try {	  
      String str_param1 = getParameter("parametro1");  // pega o valor do parmetro "parametro1" no HTML (se existir)
      str_msg = new String(str_param1); // redefine contedo da mensagem
    } catch (java.lang.NullPointerException npe) {
      System.out.println("Applet se parmetro: <param name=\"parametro1\" value=\"coloque msg aqui\">");
      }
     
    this.montaJanela(); //  possvel fazer isso em funo do "init()"
                        // s ser chamado aps criar a instncia da classe principal  
    }

  // Inicia quando Aplicativo (antes do construtor)
  public static void main (String[] args) {
    TrataMouse trataM = new TrataMouse();
    trataM.montaJanela();
    }

  }
